Imports System.Reflection
Imports System.Collections.Generic
Imports System.Drawing.Drawing2D

Public Class Form1
    Private Const XMIN As Integer = 10
    Private Const SAMPLE_WID As Integer = 120
    Private Const SAMPLE_HGT As Integer = 30
    Private Const X_MARGIN As Integer = 10
    Private Const Y_MARGIN As Integer = 20

    ' Prepare for Paint events.
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.SetStyle( _
            ControlStyles.AllPaintingInWmPaint Or _
            ControlStyles.ResizeRedraw Or _
            ControlStyles.OptimizedDoubleBuffer, _
            True)
        Me.UpdateStyles()

        Me.ClientSize = New Size( _
            2 * XMIN + 6 * SAMPLE_WID + 5 * X_MARGIN, _
            3 * XMIN + 10 * SAMPLE_HGT + 9 * Y_MARGIN)
    End Sub

    ' Display brush samples.
    Private Sub Form1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Me.Paint
        e.Graphics.Clear(Me.BackColor)
        Dim x As Integer = XMIN
        Dim y As Integer = XMIN
        
        ' Enumerate the HatchBrush styles.
        Dim hatch_style_type As Type = GetType(HatchStyle)

        Dim field_infos() As FieldInfo = hatch_style_type.GetFields()
        For Each field_info As FieldInfo In field_infos
            ' See if this is a static (Shared) property.
            ' We only want the Shared properties such as Horizontal
            ' and not the instance properties such as value__.
            If field_info.IsStatic Then
                ' Get this brush.
                Dim style_obj As Object = field_info.GetValue(Nothing)
                Dim hatch_style As HatchStyle = DirectCast(style_obj, HatchStyle)

                ' Make the brush and draw the sample.
                Using br As New HatchBrush(hatch_style, Color.Black, Color.White)
                    DrawSample(e.Graphics, x, y, br, field_info.Name)
                End Using
            End If
        Next field_info
    End Sub

    ' Draw the sample and move (x, y) to a new position.
    Private Sub DrawSample(ByVal gr As Graphics, ByRef x As Integer, ByRef y As Integer, ByVal br As Brush, ByVal brush_name As String)
        ' Draw the sample.
        gr.FillRectangle(br, x, y, SAMPLE_WID, SAMPLE_HGT)
        gr.DrawRectangle(Pens.Red, x, y, SAMPLE_WID, SAMPLE_HGT)

        ' Draw the brush's name.
        Dim string_format As New StringFormat()
        string_format.Alignment = StringAlignment.Center
        string_format.LineAlignment = StringAlignment.Near
        gr.DrawString(brush_name, Me.Font, Brushes.Blue, _
            x + SAMPLE_WID \ 2, y + SAMPLE_HGT, string_format)

        ' Update x and y.
        x += SAMPLE_WID + X_MARGIN
        If x + SAMPLE_WID > Me.ClientSize.Width Then
            x = XMIN
            y += SAMPLE_HGT + Y_MARGIN
        End If
    End Sub
End Class
